package cn.newfeifan.mall.module.distri.service.sharepath;

import java.util.*;
import javax.validation.*;

import cn.newfeifan.mall.module.distri.controller.admin.sharepath.vo.*;
import cn.newfeifan.mall.module.distri.dal.dataobject.duser.DuserDO;
import cn.newfeifan.mall.module.distri.dal.dataobject.ordercalc.OrderCalcDO;
import cn.newfeifan.mall.module.distri.dal.dataobject.sharepath.SharePathDO;
import cn.newfeifan.mall.framework.common.pojo.PageResult;
import cn.newfeifan.mall.module.member.controller.admin.user.vo.MemberUserRespVO;
import cn.newfeifan.mall.module.member.controller.admin.user.vo.MemberUserUpdateReqVO;
import cn.newfeifan.mall.module.member.dal.dataobject.user.MemberUserDO;

/**
 * 分销用户关系 Service 接口
 *
 * @author 非繁人
 */
public interface SharePathService {

    void createSharePathByUserId(SharePathSaveReqVO createReqVO,Boolean isNew);

    void createSharePathByUserId(List<Long> userIds);


    /**
     * 更新分销用户关系
     *
     * @param updateReqVO 更新信息
     */
    void updateSharePath(@Valid SharePathSaveReqVO updateReqVO);

    /**
     * 删除分销用户关系
     *
     * @param id 编号
     */
    void deleteSharePath(Long id);

    /**
     * 获得分销用户关系
     *
     * @param id 编号
     * @return 分销用户关系
     */
    SharePathDO getSharePath(Long id);

    /**
     * 获得分销用户关系分页
     *
     * @param pageReqVO 分页查询
     * @return 分销用户关系分页
     */
    PageResult<SharePathDO> getSharePathPage(SharePathPageReqVO pageReqVO);




    /**
     * 转让分销用户关系
     *
     * @param sharePathtransFerenceRelaReqVO 转让关系
     */
    void transferenceRela(SharePathtransFerenceRelaReqVO sharePathtransFerenceRelaReqVO);


    /**
     * 通过直推人, 获取当前的直推关系
     *
     * @param userId 用户id
     * @return 推荐人
     */
    SharePathDO getSharePathByDescendant(Long userId);


    /**
     * 获取儿子订单计算分区
     *
     * @param userId 用户id
     * @return 订单计算
     */
    List<OrderCalcDO> selectSons(Long userId, List<Long> userIds);

    /**
     * 获取兄弟订单分区
     *
     * @param userId  用户id
     * @param userId1 ids
     * @param user 用户
     * @return 订单计算
     */
    List<OrderCalcDO> selectBrothers(Long userId, List<Long> userId1, MemberUserDO user);

    Long queryParentBySonUserId(Long userId);

    List<DuserDO> selectSon(Long userId);


    List<Long> sonsId(Long userId);

    PageResult<SharePathRespVO> getDescendants(SharePathPageReqVO pageReqVO);
    TreeNode getTree(Long userId,  Integer maxDepth);

    TreeNode getTreeByNameOrMobile(SharePathTreeReqVO sharePathTreeReqVO);

    MemberUserRespVO getMemberUser(Long userId);

    /**
     * 【管理员】更新会员用户
     *
     * @param updateReqVO 更新信息
     */
    void updateUser(MemberUserUpdateReqVO updateReqVO);
}